# $Id: Login.pm 29029 2009-10-18 10:24:07Z wsl $
# $URL: https://infix.uvt.nl/its-id/trunk/sources/aselect-perl/lib/Aselect/Login.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package Aselect::Login;

use Aselect::Generator -Base;
use Aselect::Database -mixin;

use Aselect::Util;

field 'info';

sub redirect {
	my $url = $_[0];

	my $req = $self->req;
	$req->code(302);
	$req->setheader(Location => $url);
}

sub work {
	my $req = $self->req;
	my $cfg = $self->cfg;
	my $rid = $req->param('rid');
	my $info = $self->rid($rid);
	if(!$info) {
		my $url = $req->url;
		$url =~ s,/*$,/error,;
		return $self->redirect(aselect_url($url, {error_code => '0030'}));
	}
	$self->info($info);

	my $sessioncookie = $req->cookie('session');
	my $session = $self->session($sessioncookie);

	if(!$session) {
		my $login = $self->login;
		if($login) {
			my ($uid, $org, $attrs) = @$login{qw(uid organization attributes)};
			$attrs = aselect_encode(%$attrs) if defined $attrs;
			$sessioncookie = $self->random_hexbytes(16);
			$session = $self->session($sessioncookie, $uid, $org, $attrs);
			$req->setcookie(session => $sessioncookie, 'max-age' => $cfg->timeout);
		} else {
			return super;
		}
	}

	my $credentials = $self->random_hexbytes(16);
	my $ticket = $self->ticket($credentials, $session, $info);

	my $id = $cfg->id || $req->virtual_host;

	return $self->redirect(aselect_url($info->{app_url}, {
			aselect_credentials => $ticket->{credentials},
			rid => $rid,
			'a-select-server' => $id,
		}));
}
